﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Threading;
using WpfAnimatedGif;

namespace WpfApp1
{
    /// <summary>
    /// LoadingProcess.xaml에 대한 상호 작용 논리
    /// </summary>
    public partial class LoadingProcess : Window
    {
        public LoadingProcess()
        {
            InitializeComponent();


            this.Dispatcher.BeginInvoke(DispatcherPriority.Normal, (ThreadStart)delegate ()
            {
                const int loadingPixel = 80;

                Image loadingImage = new Image();
                loadingImage.Width = loadingPixel;
                loadingImage.Height = loadingPixel;

                BitmapImage loadingBitmapImage = new BitmapImage();
                loadingBitmapImage.BeginInit();
                loadingBitmapImage.UriSource = new Uri($"pack://application:,,,/Images/Main/loading.gif");
                loadingBitmapImage.EndInit();

                ImageBehavior.SetAnimatedSource(loadingImage, loadingBitmapImage);
                //ImageBehavior.SetRepeatBehavior(loadingImage, new RepeatBehavior(0));
                ImageBehavior.SetRepeatBehavior(loadingImage, RepeatBehavior.Forever);

                TextBlock loadingTextBlock = new TextBlock();
                loadingTextBlock.Width = loadingPixel * 2;
                loadingTextBlock.Height = loadingPixel;
                loadingTextBlock.Padding = new Thickness(10, 25, 0, 25);
                loadingTextBlock.Text = "Please wait.";
                loadingTextBlock.FontSize = 30;
                loadingTextBlock.FontFamily = new FontFamily("Arno Pro");
                loadingTextBlock.FontWeight = FontWeights.SemiBold;
                loadingTextBlock.Foreground = new SolidColorBrush(Color.FromRgb(41, 57, 86));
                loadingTextBlock.Background = Brushes.White;

                DockPanel loadingDockPanel = new DockPanel();
                DockPanel.SetDock(loadingImage, Dock.Left);
                DockPanel.SetDock(loadingTextBlock, Dock.Right);
                loadingDockPanel.Width = loadingPixel * 3;
                loadingDockPanel.Height = loadingPixel;
                loadingDockPanel.Children.Add(loadingImage);
                loadingDockPanel.Children.Add(loadingTextBlock);

                Border loadingBorder = new Border();
                loadingBorder.BorderThickness = new Thickness(1);
                loadingBorder.BorderBrush = new SolidColorBrush(Color.FromRgb(41, 57, 86));
                loadingBorder.Width = loadingPixel * 3;
                loadingBorder.Height = loadingPixel;
                loadingBorder.Child = loadingDockPanel;

                Grid_LoadingProcess.Children.Add(loadingBorder);
            });
        }
    }
}
